/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.testblock.blockcounter;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.bausystem.features.tpslimit.TPSUtils;
import de.steamwar.bausystem.region.Region;
import de.steamwar.bausystem.region.RegionUtils;
import lombok.ToString;
import org.bukkit.block.Block;
import org.bukkit.scheduler.BukkitTask;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

@ToString
public class BlockCount {

    private static BukkitTask bukkitTask = null;

    private Region region;
    private int count = 0;
    private int tntCount = 0;
    private final long tick = TPSUtils.currentRealTick.get();

    private long lastUpdate = TPSUtils.currentRealTick.get();

    public BlockCount(Region region) {
        this.region = region;

        if (bukkitTask == null) {
            bukkitTask = BauSystem.runTaskTimer(BauSystem.getInstance(), () -> {
                Set<Region> toRemove = new HashSet<>();
                for (BlockCount blockCount : BlockCounter.blockCountMap.values()) {
                    if (TPSUtils.currentRealTick.get() - blockCount.lastUpdate < 60) {
                        continue;
                    }
                    toRemove.add(blockCount.region);

                    if (count > 10) {
                        RegionUtils.message(blockCount.region, player -> {
                            return BlockCounter.getMessage(player, blockCount.count, blockCount.tntCount, blockCount.tick, blockCount.lastUpdate);
                        });
                    }
                }
                toRemove.forEach(BlockCounter.blockCountMap::remove);
                if (BlockCounter.blockCountMap.isEmpty()) {
                    bukkitTask.cancel();
                    bukkitTask = null;
                }
            }, 2, 2);
        }
    }

    public void update(List<Block> blocks) {
        count += blocks.size();
        tntCount++;
        lastUpdate = TPSUtils.currentRealTick.get();
    }
}
